## openjdk-17 17.0.2+8

=== src/demo/share/java2d/J2DBench/Makefile ===
#
# Copyright (c) 2002, 2021, Oracle and/or its affiliates. All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#
#   - Neither the name of Oracle nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
# IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

SOURCEPATH=src
CLASSES=build
DIST=dist
RESOURCES=resources

J2DBENCH_CLASSES = \
	$(CLASSES)/j2dbench/J2DBench.class \
	$(CLASSES)/j2dbench/Destinations.class \
	$(CLASSES)/j2dbench/Group.class \
	$(CLASSES)/j2dbench/Result.class \
	$(CLASSES)/j2dbench/Modifier.class \
	$(CLASSES)/j2dbench/Node.class \
	$(CLASSES)/j2dbench/Option.class \
	$(CLASSES)/j2dbench/ResultSet.class \
	$(CLASSES)/j2dbench/TestEnvironment.class \
	$(CLASSES)/j2dbench/Test.class \
	$(CLASSES)/j2dbench/ui/EnableButton.class \
	$(CLASSES)/j2dbench/ui/CompactLayout.class \
	$(CLASSES)/j2dbench/tests/ImageTests.class \
	$(CLASSES)/j2dbench/tests/RenderTests.class \
	$(CLASSES)/j2dbench/tests/PixelTests.class \
	$(CLASSES)/j2dbench/tests/MiscTests.class \
	$(CLASSES)/j2dbench/tests/iio/IIOTests.class \
	$(CLASSES)/j2dbench/tests/iio/InputTests.class \
	$(CLASSES)/j2dbench/tests/iio/InputImageTests.class \
	$(CLASSES)/j2dbench/tests/iio/InputStreamTests.class \
	$(CLASSES)/j2dbench/tests/iio/OutputTests.class \
	$(CLASSES)/j2dbench/tests/iio/OutputImageTests.class \
	$(CLASSES)/j2dbench/tests/iio/OutputStreamTests.class \
	$(CLASSES)/j2dbench/tests/text/TextConstructionTests.class \
	$(CLASSES)/j2dbench/tests/text/TextMeasureTests.class \
	$(CLASSES)/j2dbench/tests/text/TextRenderTests.class \
	$(CLASSES)/j2dbench/tests/text/TextTests.class \
	$(CLASSES)/j2dbench/tests/GraphicsTests.class

J2DANALYZER_CLASSES = \
	$(CLASSES)/j2dbench/report/IIOComparator.class \
	$(CLASSES)/j2dbench/report/HTMLSeriesReporter.class \
	$(CLASSES)/j2dbench/report/J2DAnalyzer.class \
	$(CLASSES)/j2dbench/report/XMLHTMLReporter.class

J2DBENCH_RESOURCES = \
	$(CLASSES)/j2dbench/tests/iio/images \
	$(CLASSES)/j2dbench/tests/cmm/images \
	$(CLASSES)/j2dbench/tests/text/textdata

SCM_DIRs = .hg .svn CVS RCS SCCS Codemgr_wsdata deleted_files

all: mkdirs J2DBench.jar J2DAnalyzer.jar

run: mkdirs J2DBench.jar
	java -jar $(DIST)/J2DBench.jar

analyze: mkdirs J2DAnalyzer.jar
	java -jar $(DIST)/J2DAnalyzer.jar

J2DBench.jar: \
	$(J2DBENCH_CLASSES) $(J2DBENCH_RESOURCES) \
	$(CLASSES)/j2dbench.manifest
	jar cvmf $(CLASSES)/j2dbench.manifest $(DIST)/J2DBench.jar -C $(CLASSES) j2dbench

J2DAnalyzer.jar: $(J2DANALYZER_CLASSES) $(CLASSES)/j2danalyzer.manifest
	jar cvmf $(CLASSES)/j2danalyzer.manifest \
		$(DIST)/J2DAnalyzer.jar -C $(CLASSES) j2dbench/report

$(CLASSES)/j2dbench/tests/iio/images: $(RESOURCES)/images
	cp -r $< $@
	cd $@ && rm -rf $(SCM_DIRs)

$(CLASSES)/j2dbench/tests/text/textdata: $(RESOURCES)/textdata
	cp -r $< $@
	cd $@ && rm -rf $(SCM_DIRs)

$(CLASSES)/j2dbench/tests/cmm/images: $(RESOURCES)/cmm_images
	cp -r $< $@
	cd $@ && rm -rf $(SCM_DIRs)

$(CLASSES)/j2dbench.manifest:
	echo "Main-Class: j2dbench.J2DBench" > $@

$(CLASSES)/j2danalyzer.manifest:
	echo "Main-Class: j2dbench.report.J2DAnalyzer" > $@

$(DIST):
	mkdir $(DIST)
$(CLASSES):
	mkdir $(CLASSES)

mkdirs: $(DIST) $(CLASSES)

$(CLASSES)/j2dbench/%.class: $(SOURCEPATH)/j2dbench/%.java
	javac -g:none -source 1.7 -target 1.7 -d $(CLASSES) -sourcepath $(SOURCEPATH) $<

clean:
	rm -rf $(CLASSES)
	rm -rf $(DIST)

## openjdk-17 17~17

=== debian/changelog ===
openjdk-17 (17~17-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 17.
  * Prefer to build using openjdk-17 instead of -16. Closes: #986526.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 08 Apr 2021 09:37:40 +0200

openjdk-17 (17~15-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 15.
  * Fix another upstream typo to build with external harfbuzz. Closes: #985668.
  * Disable running the tests on mipsel and mips64el.  Times out, and if it
    succeeds, it taken at least five days to run.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 25 Mar 2021 10:31:15 +0100

openjdk-17 (17~14-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 14.
  * Don't use the triplet-prefixed binutils tools for backports.
  * Simplify compiler selection for backports.
  * Fix build with older glibc versions. See JDK-8262501.
  * Apply untested patch suggested to fix mips issue. See #983878.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 18 Mar 2021 19:42:16 +0100

openjdk-17 (17~11-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 11.
  * Configure --with-copyright-year. Addresses: #956154.
  * Restore the libpcsclite-dlopen patch. Closes: #983465.
  * Don't run the testsuite on armel and riscv64. Crashing the buildds.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 25 Feb 2021 10:33:32 +0100

openjdk-17 (17~10-2) unstable; urgency=medium

  * Fix the build logic, jaotc and jhsdb tools not available on all archs.
  * Ship the jfc files used by jfr.
  * reproducible-build-jmod.diff: Fall back to the unpatched behavior
    for backports.
  * Only build with system harfbuzz for recent releases.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 20 Feb 2021 12:02:45 +0100

openjdk-17 (17~10-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 10.
  * Fix building with OpenJDK 17 as the boot jdk.
  * Build with Rules-Requires-Root: no.
  * Move libawt_xawt.so, libjawt.so into the jre package. Addresses: #908058.
  * Move the jfr binary from -jre-headless to -jdk-headless. Development tool.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 19 Feb 2021 13:12:19 +0100

openjdk-17 (17~9-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 9.
  * Enable running the tests.
  * Remove the disable-doclint-by-default patch. Was not applied anymore
    in 17.  Closes: #982521.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 11 Feb 2021 10:13:25 +0000

openjdk-17 (17~8-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 8.
  * Don't try to apply the removed alpha-float-const patch.
  * Drop the powerpcspe packaging bits.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Feb 2021 14:35:28 +0100

openjdk-17 (17~7-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 7.
  * Update watch file.
  * Use debugedit to generate unique build-id's and remove the openjdk-N-dbg
    file conflicts.
  * Remove KFreeBSD build support and patches, not updated since OpenJDK 8.
  * Remove obsolete patches: alpha-float-const, libpcsclite-dlopen,
    parallel-build-fix, s390x-thread-stack-size.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 28 Jan 2021 14:52:27 +0100

openjdk-17 (17~5-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 5.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Jan 2021 10:29:50 +0100

openjdk-17 (17~4-0ubuntu1) hirsute; urgency=medium

  * OpenJDK 17 snapshot, build 4.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 09 Jan 2021 17:25:46 +0100

openjdk-17 (17~3-1) experimental; urgency=medium

  * OpenJDK 17 snapshot, build 3.
  * OpenJDK 17 is supposed to be the next OpenJDK LTS release seeing extended
    updates and security support.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 28 Dec 2020 13:57:12 +0100

openjdk-16 (16~29-1) unstable; urgency=medium

  * OpenJDK 16 snapshot, build 29.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 28 Dec 2020 12:44:30 +0100

openjdk-16 (16~27-2) unstable; urgency=medium

  * Fix installation on sparc64.
  * Link with libatomic for more zero builds.
  * Re-enable zero on armhf.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 04 Dec 2020 10:01:45 +0100

openjdk-16 (16~27-1) unstable; urgency=medium

  * OpenJDK 16 snapshot, build 27.
  * Bump standards version.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 03 Dec 2020 16:42:51 +0100

openjdk-16 (16~14-1) experimental; urgency=medium

  * OpenJDK 16 snapshot, build 14.
  * Build with system harfbuzz.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 07 Nov 2020 14:35:22 +0100

openjdk-15 (15.0.1+9-3) unstable; urgency=medium

  * Don't enabled shenandoahgc explicitly.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 07 Nov 2020 08:54:13 +0100

openjdk-15 (15.0.1+9-2) unstable; urgency=medium

  * Update debian/copyright.
  * Configure --with-jvm-features=shenandoahgc for hotspot builds.
    LP: #1902029.
  * Replace the upstream test suite in the autopkg tests with two superficial
    tests. It doesn't make any sense to run the whole test suite again,
    after running it during the build.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Nov 2020 16:55:34 +0100

openjdk-15 (15.0.1+9-1) unstable; urgency=medium

  * OpenJDK 15.0.1 release, build 9.
  * Build just zero on sparc64 (Adrian Glaubitz). Closes: #965342.
  * Call strip-nondeterminism before computing jmod hashes (Julian Gilbey).
  * Don't run the jdk tests as an autopkg test, taking too long.
    Closes: #970606.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 21 Oct 2020 16:46:35 +0200

openjdk-15 (15+36-1) unstable; urgency=medium

  * OpenJDK 15 release, build 36.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 16 Sep 2020 14:08:36 +0200

openjdk-15 (15~32-2) unstable; urgency=medium

  * debian/copyright (remove licenses not found anymore in the sources):
    - Little CMS, libpng, GIFLIB.
  * Stop building zero on armhf, ftbfs.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 19 Jul 2020 10:36:08 +0200

openjdk-15 (15~32-1) unstable; urgency=medium

  * OpenJDK 15 snapshot, build 32.
  * Build again with -march=zEC12 on Ubuntu/s390x.


=== debian/control ===
Source: openjdk-17
Section: java
Priority: optional
Maintainer: OpenJDK Team <openjdk-17@packages.debian.org>
Uploaders: Matthias Klose <doko@ubuntu.com>
Build-Depends: debhelper (>= 11),
  m4, lsb-release, zip, unzip,
  sharutils, gawk, cpio, pkg-config, procps, wdiff, fastjar (>= 2:0.96-0ubuntu2),
  time, strip-nondeterminism, debugedit (>= 4.16),
  jtreg (>= 5.1-b1-0~) <!nocheck>, testng <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>,
  autoconf, automake, autotools-dev, ant, ant-optional,
  g++-10 <!cross>,
  openjdk-17-jdk-headless:native | openjdk-16-jdk-headless:native,
  libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libfreetype6-dev (>= 2.2.1), libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig1-dev, libgtk2.0-0 | libgtk-3-0, libharfbuzz-dev,
  libffi-dev,
  zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, 
  libnss3-dev (>= 2:3.17.1),
  openjdk-17-jdk-headless <cross>,
Build-Depends-Indep: graphviz, pandoc,
Rules-Requires-Root: no
Standards-Version: 4.5.1
Homepage: https://openjdk.java.net/
Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk
Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git

Package: openjdk-17-jdk-headless
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-17-jre-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Suggests: openjdk-17-demo, openjdk-17-source
Provides: java-sdk-headless, java2-sdk-headless,
  java5-sdk-headless, java6-sdk-headless,
  java7-sdk-headless, java8-sdk-headless,
  java9-sdk-headless, java10-sdk-headless,
  java11-sdk-headless, java12-sdk-headless,
  java13-sdk-headless, java14-sdk-headless, java15-sdk-headless,
  java16-sdk-headless, java17-sdk-headless,
  java-compiler
Breaks: openjdk-17-jre-headless (<< 17~10)
Replaces: openjdk-17-jre-headless (<< 17~10)
Description: OpenJDK Development Kit (JDK) (headless)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-17-jre-headless
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: ${jredefault:Depends}, ${cacert:Depends},
  ${jcommon:Depends}, ${dlopenhl:Depends},
  ${mountpoint:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenhl:Recommends}
Suggests: libnss-mdns,
  fonts-dejavu-extra,
  fonts-ipafont-gothic, fonts-ipafont-mincho, fonts-wqy-microhei | fonts-wqy-zenhei, fonts-indic,
Provides: java-runtime-headless, java2-runtime-headless,
  java5-runtime-headless, java6-runtime-headless,
  java7-runtime-headless, java8-runtime-headless,
  java9-runtime-headless, java10-runtime-headless,
  java11-runtime-headless, java12-runtime-headless,
  java13-runtime-headless, java14-runtime-headless, java15-runtime-headless,
  java16-runtime-headless, java17-runtime-headless,
  ${defaultvm:Provides}, ${jvm:Provides}
Breaks: ${jrehl:Breaks}
Conflicts: oracle-java11-installer, openjdk-11-jdk-headless (<< 11~18-2)
Replaces: openjdk-11-jdk-headless (<< 11~18-2)
Description: OpenJDK Java runtime, using ${vm:Name} (headless)
 Minimal Java runtime - needed for executing non GUI Java programs,
 using ${vm:Name}.

Package: openjdk-17-jdk
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-17-jre (= ${binary:Version}),
  openjdk-17-jdk-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libxt-dev
Suggests: openjdk-17-demo, openjdk-17-source, visualvm
Provides: java-sdk, java2-sdk, java5-sdk, java6-sdk,
  java7-sdk, java8-sdk, java9-sdk, java10-sdk, java11-sdk,
  java12-sdk, java13-sdk, java14-sdk, java15-sdk, java16-sdk, java17-sdk,
  java-compiler
Description: OpenJDK Development Kit (JDK)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-17-jre
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-17-jre-headless (= ${binary:Version}),
  ${xandsound:Depends}, ${dlopenjre:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenjre:Recommends}, ${bridge:Recommends}, fonts-dejavu-extra
Provides: java-runtime, java2-runtime,
  java5-runtime, java6-runtime,
  java7-runtime, java8-runtime,
  java9-runtime, java10-runtime,
  java11-runtime, java12-runtime,
  java13-runtime, java14-runtime, java15-runtime,
  java16-runtime, java17-runtime,
Breaks: openjdk-17-jre-headless (<< 17~10)
Replaces: openjdk-17-jre-headless (<< 17~10)
Description: OpenJDK Java runtime, using ${vm:Name}
 Full Java runtime environment - needed for executing Java GUI and Webstart
 programs, using ${vm:Name}.

Package: openjdk-17-demo
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-17-jre (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Description: Java runtime based on OpenJDK (demos and examples)
 OpenJDK Java runtime

Package: openjdk-17-source
Architecture: all
Multi-Arch: foreign
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-17-jdk (>= ${source:Version}),
  ${misc:Depends}
Description: OpenJDK Development Kit (JDK) source files
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the Java programming language source files
 (src.zip) for all classes that make up the Java core API.

Package: openjdk-17-doc
Section: doc
Pre-Depends: ${dpkg:Depends}
Architecture: all
Multi-Arch: foreign
Priority: optional
Depends: ${misc:Depends},
  libjs-jquery,
  libjs-jquery-ui,
  libjs-jquery-ui-theme-base,
Suggests: openjdk-17-jdk
Description: OpenJDK Development Kit (JDK) documentation
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the API documentation.

Package: openjdk-17-dbg
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Priority: optional
Section: debug
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-17-jre-headless (= ${binary:Version}),
   ${misc:Depends}
Recommends: openjdk-17-jre (= ${binary:Version})
Suggests: openjdk-17-jdk (= ${binary:Version})
Conflicts: ${dbg:Conflicts}
Description: Java runtime based on OpenJDK (debugging symbols)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the debugging symbols.

Package: openjdk-17-jre-zero
Architecture: amd64 i386 arm64 armhf ppc64 ppc64el s390x
Multi-Arch: same
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-17-jre-headless (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: ${zerovm:Provides}
Description: Alternative JVM for OpenJDK, using Zero
 The package provides an alternative runtime using the Zero VM. Built on
 architectures in addition to the Hotspot VM as a debugging aid for those
 architectures which don't have a Hotspot VM.
 .
 The VM is started with the option `-zero'. See the README.Debian for details.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

unexport LANG LC_ALL

dh_version := $(shell dpkg-query -f '$${Version}\n' -W debhelper | sed -n 's/^\(.\).*/\1/p')

# using brace expansion and substring replacements (${var:0:2}).
SHELL = /bin/bash

# use gnu time in verbose mode if available, otherwise default to the shell builtin
ifneq (,$(wildcard /usr/bin/time))
  TIME = /usr/bin/time -v
else
  TIME = time
endif

vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))

DPKG_VARS		:= $(shell dpkg-architecture)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_HOST_ARCH_CPU	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_CPU)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

PATH := $(CURDIR)/bin:$(PATH)
export PATH

CHANGELOG_VARS := $(shell dpkg-parsechangelog | sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)
PKGYEAR := $(shell echo $(call vafilt,$(CHANGELOG_VARS),Timestamp) | date --utc +%Y)

distribution := $(shell lsb_release --id --short)
distrel := $(shell lsb_release --codename --short)
derivative := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
               elif dpkg-vendor --derives-from Debian; then echo Debian; \
               else echo Unknown; fi)
ifeq ($(distrel),n/a)
  distrel := sid
endif

ifneq (,$(filter $(distrel),precise))
  OBJCOPY := objcopy
  STRIP := strip
else
  OBJCOPY := $(DEB_HOST_GNU_TYPE)-objcopy
  STRIP := $(DEB_HOST_GNU_TYPE)-strip
endif

multiarch_dir = /$(DEB_HOST_MULTIARCH)

hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el s390x
jtreg_archs	= $(hotspot_archs) alpha ia64 powerpc ppc64 sh4 x32
jtreg_archs	+= armel mipsel mips64el
jtreg_archs	+= riscv64

# FIXME: use bootcycle builds for zero archs?
bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),yes)
#bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), amd64 i386),yes)
#bootcycle_build =
zbootcycle_build =
zbootcycle_build = yes
ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
  bootcycle_build =
  zbootcycle_build =
endif
ifneq (,$(filter nobootcycle, $(DEB_BUILD_OPTIONS)))
  bootcycle_build =
  zbootcycle_build =
endif

ifneq (,$(filter $(distrel),lucid precise quantal raring saucy trusty utopic vivid wily lenny etch squeeze wheezy jessie))
  is_default = no
else
  is_default = yes
endif

#is_upstream_release = yes

srcdir		= .
builddir	= build
zbuilddir	= build-zero

VENDOR		= openjdk
Vendor		= OpenJDK
TOP		= usr/lib/jvm
origin		= openjdk
basename	= openjdk-$(shortver)
ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))
  priority	= $(if $(filter yes, $(is_default)),1711,1709)
  vm_name	= Hotspot JIT
else
  priority	= $(if $(filter yes, $(is_default)),1704,1703)
  vm_name	= Hotspot Zero
endif
jvmver		= 1.17.0
shortver	= 17
v_upstream	:= $(shell echo $(PKGVERSION) | sed 's/-[^-][^-]*$$//')
v_pkgrel	:= $(shell echo $(PKGVERSION) | sed 's/^.*-//')
# FIXME. currently v_upstream like 11~4
#v_upbase	:= $(word 1, $(subst +, , $(v_upstream)))
#v_upbuild	:= $(word 2, $(subst +, , $(v_upstream)))
v_upbase	:= $(word 1, $(subst ~, , $(v_upstream)))
v_upbuild	:= $(word 2, $(subst ~, , $(v_upstream)))
# that should be the package version ...

#$(warning XXXXX $(v_upstream) / $(v_pkgrel) / $(v_upbase) / $(v_upbuild))

#ifneq ($(PKGVERSION),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
#  $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(PKGVERSION))
#endif
ifneq ($(PKGVERSION),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
  $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(PKGVERSION))
endif

ifneq (,$(DEB_HOST_MULTIARCH))
  jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
  jdiralias	= java-$(jvmver)-$(origin)-$(DEB_HOST_ARCH)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)-common
  commonbasedir	= $(basedir)
  etcdir	= etc/java-$(shortver)-$(origin)
else
  jdirname	= java-$(shortver)-$(origin)
  jdiralias	= java-$(jvmver)-$(origin)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)
  etcdir	= etc/$(jdirname)
endif
security	= $(etcdir)/security
ifeq ($(bootcycle_build),yes)
  sdkimg	= bootcycle-build/images/jdk
  build_target	= bootcycle-images test-image
else
  sdkimg	= images/jdk
  build_target	= images test-image
endif
ifeq ($(zbootcycle_build),yes)
  zsdkimg	= bootcycle-build/images/jdk
  zbuild_target	= bootcycle-images test-image
else
  zsdkimg	= images/jdk
  zbuild_target	= images test-image
endif

# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
COMMA=,
SPACE = $(EMPTY) $(EMPTY)
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS = $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

with_check = $(if $(findstring nocheck, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(DEB_HOST_ARCH), alpha armel mipsel mips64el riscv64))
  with_check = disabled running check on $(DEB_HOST_ARCH)
endif
# no jtreg backport yet
ifneq (,$(filter $(distrel), precise trusty xenial bionic))
  with_check = disabled for $(distrel)
endif
#with_check = disabled, more recent jtreg needed

with_docs = $(if $(findstring nodoc, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(distrel), precise trusty))
  with_docs =
endif
#with_check = disabled for this upload

with_wqy_zenhai = $(if $(filter $(distrel),lenny),,yes)

arch_map	:= alpha=alpha arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 m68k=m68k mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc ppc64=ppc64 ppc64el=ppc64le riscv64=riscv64 sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32

jvmarch		:= $(strip $(patsubst $(DEB_HOST_ARCH_CPU)=%, %, \
			$(filter $(DEB_HOST_ARCH_CPU)=%, $(arch_map))))
ifeq ($(DEB_HOST_ARCH),x32)
  jvmarch := x32
endif

default_vm = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),hotspot,zero)

any_archs = alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32

altzero_archs = $(hotspot_archs)
ifneq (,$(filter $(distrel),trusty))
  altzero_archs := $(filter-out arm64, $(altzero_archs))
endif
# FIXME: https://launchpad.net/ubuntu/+source/openjdk-lts/11.0.5+6-1ubuntu1
# ftbfs on armhf, also in OpenJDK 15, now fixed in 16?
#altzero_archs := $(filter-out armhf, $(altzero_archs))

ifneq (,$(filter noaltzero, $(DEB_BUILD_OPTIONS)))
  altzero_archs =
else ifneq (,$(filter $(DEB_HOST_ARCH), $(altzero_archs)))
  alternate_vms += zero
  zero_dir = zero
endif

# needed for the jexec build
export DEBIAN_JDK_BASE_DIR := /$(basedir)

BOOTJDK_HOME := $(strip $(subst /bin/javac,, $(firstword $(wildcard \
			/usr/lib/jvm/java-16-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
			/usr/lib/jvm/java-17-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
		))))

ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
  BUILDJDK_HOME = $(CURDIR)/$(builddir)/$(sdkimg)
else
  BUILDJDK_HOME = $(BOOTJDK_HOME)
endif

# for Hotspot: hotspot/make/linux/makefiles/vm.make
# Don't overwrite Hotspot opt level :
# -O3 is already default option for hotspot

# FIXME: ftbfs with -Werror=format-security
dpkg_buildflags_hs = \
	DEB_CFLAGS_MAINT_STRIP="-O2 -Werror=format-security" \
	DEB_CXXFLAGS_MAINT_STRIP="-O2 -Werror=format-security" \
	DEB_CFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations" \
	DEB_CXXFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations$(if $(filter $(DEB_HOST_ARCH), armel armhf), -fpermissive)"
# jdk/make/CompileDemos.gmk (SetupJVMTIDemo) doesn't like commas in flags
dpkg_buildflags_hs += \
	DEB_LDFLAGS_MAINT_STRIP="-Wl,-z,relro -Wl,-Bsymbolic-functions" \

=== debian/tests/control ===
Test-Command: java --version
Depends: openjdk-17-jre-headless
Restrictions: superficial

Test-Command: javac --version
Depends: openjdk-17-jdk-headless
Restrictions: superficial

#Tests: hotspot, jaxp, langtools
#Depends: @, default-jre-headless, jtreg:native (>= 5.1-b1-0~), testng:native, build-essential
#Restrictions: allow-stderr, skippable, flaky

#Tests: jdk
#Depends: @, default-jre-headless, jtreg:native (>= 5.1-b1-0~), testng:native, build-essential, xfwm4:native, xvfb, dbus-x11
#Restrictions: allow-stderr, skippable, flaky

## openjdk-17 17~19

=== debian/changelog ===
openjdk-17 (17~19-1) unstable; urgency=high

  * OpenJDK 17 snapshot, build 19.
    - Fix JDK-8250568: Less ambiguous processing (CVE-2021-2161).
    - Fix JDK-8249906: Enhance opening JARs (CVE-2021-2163).

 -- Matthias Klose <doko@ubuntu.com>  Thu, 22 Apr 2021 09:51:43 +0200

## openjdk-17 17+35

=== debian/changelog ===
openjdk-17 (17+35-1) unstable; urgency=medium

  * Fix JDK-8272472, ftbfs with glibc 2.24.

 -- Matthias Klose <doko@debian.org>  Wed, 15 Sep 2021 07:22:52 +0200

openjdk-17 (17~35ea-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 35 (first release candidate).

 -- Matthias Klose <doko@ubuntu.com>  Fri, 13 Aug 2021 13:54:06 +0200

openjdk-17 (17~33ea-1) unstable; urgency=high

  * OpenJDK 17 snapshot, build 33.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 31 Jul 2021 09:22:45 +0200

openjdk-17 (17~32ea-1) unstable; urgency=high

  * OpenJDK 17 snapshot, build 32.
  * Security fixes:
    - JDK-8256157: Improve bytecode assembly.
    - JDK-8256491: Better HTTP transport.
    - JDK-8258432, CVE-2021-2341: Improve file transfers.
    - JDK-8260453: Improve Font Bounding.
    - JDK-8260960: Signs of jarsigner signing.
    - JDK-8260967, CVE-2021-2369: Better jar file validation.
    - JDK-8262380: Enhance XML processing passes.
    - JDK-8262403: Enhanced data transfer.
    - JDK-8262410: Enhanced rules for zones.
    - JDK-8262477: Enhance String Conclusions.
    - JDK-8262967: Improve Zip file support.
    - JDK-8264066, CVE-2021-2388: Enhance compiler validation.
    - JDK-8264079: Improve abstractions.
    - JDK-8264460: Improve NTLM support.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 26 Jul 2021 11:25:32 +0200

openjdk-17 (17~31ea-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 31.
  * Encode the early-access status into the package version. LP: #1934895.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 17 Jul 2021 14:25:02 +0200

openjdk-17 (17~29-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 29.
  * Update watch file.
  * Prepare to build with jtreg6, where available.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 01 Jul 2021 16:42:23 +0200

openjdk-17 (17~27-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 27.
  * Only build using lto with GCC 11.
  * Build using GCC 11 in recent distributions.
  * Update VCS attributes.
  * Disable runnning the tests, requires not yet packaged jtreg6.
  * Remove rimd, removed upstream.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Jun 2021 15:06:18 +0200

openjdk-17 (17~24-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 24.
  * Drop the work around for JDK 8211105.
  * Remove jaotc (the experimental JIT compiler), removed upstream.
  * Add an (unapplied) patch to replace OASIS header files with ones
    imported from NSPR and NSS. See #985765.  Not reviewed, not applying.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 27 May 2021 11:26:59 +0200

=== debian/rules ===
--- 
+++ 
@@ -81,7 +81,7 @@
   is_default = yes
 endif
 
-#is_upstream_release = yes
+is_upstream_release = yes
 
 srcdir		= .
 builddir	= build
@@ -101,23 +101,24 @@
 endif
 jvmver		= 1.17.0
 shortver	= 17
-v_upstream	:= $(shell echo $(PKGVERSION) | sed 's/-[^-][^-]*$$//')
-v_pkgrel	:= $(shell echo $(PKGVERSION) | sed 's/^.*-//')
+v_debian	:= $(shell echo $(PKGVERSION) | sed 's/ea//')
+v_upstream	:= $(shell echo $(v_debian) | sed 's/-[^-][^-]*$$//')
+v_pkgrel	:= $(shell echo $(v_debian) | sed 's/^.*-//')
 # FIXME. currently v_upstream like 11~4
-#v_upbase	:= $(word 1, $(subst +, , $(v_upstream)))
-#v_upbuild	:= $(word 2, $(subst +, , $(v_upstream)))
-v_upbase	:= $(word 1, $(subst ~, , $(v_upstream)))
-v_upbuild	:= $(word 2, $(subst ~, , $(v_upstream)))
+v_upbase	:= $(word 1, $(subst +, , $(v_upstream)))
+v_upbuild	:= $(word 2, $(subst +, , $(v_upstream)))
+#v_upbase	:= $(word 1, $(subst ~, , $(v_upstream)))
+#v_upbuild	:= $(word 2, $(subst ~, , $(v_upstream)))
 # that should be the package version ...
 
 #$(warning XXXXX $(v_upstream) / $(v_pkgrel) / $(v_upbase) / $(v_upbuild))
 
-#ifneq ($(PKGVERSION),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
-#  $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(PKGVERSION))
+ifneq ($(v_debian),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
+  $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
+endif
+#ifneq ($(v_debian),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
+#  $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
 #endif
-ifneq ($(PKGVERSION),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
-  $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(PKGVERSION))
-endif
 
 ifneq (,$(DEB_HOST_MULTIARCH))
   jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
@@ -156,21 +157,22 @@
   NJOBS = $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
 endif
 
+jtreg_pkg = jtreg6
+
 with_check = $(if $(findstring nocheck, $(DEB_BUILD_OPTIONS)),,yes)
 ifneq (,$(filter $(DEB_HOST_ARCH), alpha armel mipsel mips64el riscv64))
   with_check = disabled running check on $(DEB_HOST_ARCH)
 endif
 # no jtreg backport yet
-ifneq (,$(filter $(distrel), precise trusty xenial bionic))
-  with_check = disabled for $(distrel)
-endif
-#with_check = disabled, more recent jtreg needed
+ifneq (,$(filter $(distrel), buster bullseye precise trusty xenial bionic focal groovy hirsute impish))
+  with_check = disabled for $(distrel), no $(jtreg_pkg)
+endif
 
 with_docs = $(if $(findstring nodoc, $(DEB_BUILD_OPTIONS)),,yes)
 ifneq (,$(filter $(distrel), precise trusty))
   with_docs =
 endif
-#with_check = disabled for this upload
+with_check = disabled for this upload
 
 with_wqy_zenhai = $(if $(filter $(distrel),lenny),,yes)
 
@@ -215,16 +217,22 @@
   BUILDJDK_HOME = $(BOOTJDK_HOME)
 endif
 
-# for Hotspot: hotspot/make/linux/makefiles/vm.make
-# Don't overwrite Hotspot opt level :
-# -O3 is already default option for hotspot
-
-# FIXME: ftbfs with -Werror=format-security
-dpkg_buildflags_hs = \
-	DEB_CFLAGS_MAINT_STRIP="-O2 -Werror=format-security" \
-	DEB_CXXFLAGS_MAINT_STRIP="-O2 -Werror=format-security" \
-	DEB_CFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations" \
-	DEB_CXXFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations$(if $(filter $(DEB_HOST_ARCH), armel armhf), -fpermissive)"
-# jdk/make/CompileDemos.gmk (SetupJVMTIDemo) doesn't like commas in flags
-dpkg_buildflags_hs += \
-	DEB_LDFLAGS_MAINT_STRIP="-Wl,-z,relro -Wl,-Bsymbolic-functions" \
+ifneq (,$(filter $(distrel),saucy))
+  export CC = gcc-4.8
+  export CXX = g++-4.8
+  bd_gcc = g++-4.8,
+else ifneq (,$(filter $(distrel),utopic vivid jessie))
+  export CC = gcc-4.9
+  export CXX = g++-4.9
+  bd_gcc = g++-4.9,
+else ifneq (,$(filter $(distrel),wily))
+  ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))
+    export CC = $(DEB_HOST_GNU_TYPE)-gcc-5
+    export CXX = $(DEB_HOST_GNU_TYPE)-g++-5
+    # FIXME: altzero seems to build with GCC 5 on i386, amd64, ppc64el ...
+    ifneq (,$(filter $(DEB_HOST_ARCH), arm64))
+      ZERO_CC = $(DEB_HOST_GNU_TYPE)-gcc-4.9
+      ZERO_CXX = $(DEB_HOST_GNU_TYPE)-g++-4.9
+    endif
+  else
+    export CC = $(DEB_HOST_GNU_TYPE)-gcc-4.9

## openjdk-17 17.0.1+12

=== debian/changelog ===
openjdk-17 (17.0.1+12-1~21.04) hirsute-security; urgency=medium

  * SRU: LP: #1949179: Backport the OpenJDK 17.0.1 security release.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 29 Oct 2021 11:50:31 +0200

openjdk-17 (17.0.1+12-1) unstable; urgency=medium

  * OpenJDK 17.0.1+12 (release).
  * Remove patches applied upstream.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 20 Oct 2021 16:47:06 +0200

## openjdk-17 17.0.2%2B8

=== debian/control ===
--- 
+++ 
@@ -7,9 +7,9 @@
   m4, lsb-release, zip, unzip,
   sharutils, gawk, cpio, pkg-config, procps, wdiff, fastjar (>= 2:0.96-0ubuntu2),
   time, strip-nondeterminism, debugedit (>= 4.16),
-  jtreg (>= 5.1-b1-0~) <!nocheck>, testng <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>,
+  file,
   autoconf, automake, autotools-dev, ant, ant-optional,
-  g++-10 <!cross>,
+  g++-11 <!cross>,
   openjdk-17-jdk-headless:native | openjdk-16-jdk-headless:native,
   libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libfreetype6-dev (>= 2.2.1), libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig1-dev, libgtk2.0-0 | libgtk-3-0, libharfbuzz-dev,
   libffi-dev,
@@ -20,8 +20,8 @@
 Rules-Requires-Root: no
 Standards-Version: 4.5.1
 Homepage: https://openjdk.java.net/
-Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk
-Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git
+Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk/tree/openjdk-17
+Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git -b openjdk-17
 
 Package: openjdk-17-jdk-headless
 Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32

## openjdk-17 17.0.2+8

=== debian/changelog ===
openjdk-17 (17.0.2+8-1) unstable; urgency=high

  * OpenJDK 17.0.2+8 (release).
  * Addresses security issues: CVE-2022-21366, CVE-2022-21365, CVE-2022-21360,
    CVE-2022-21341, CVE-2022-21340, CVE-2022-21305, CVE-2022-21299,
    CVE-2022-21296, CVE-2022-21294, CVE-2022-21293, CVE-2022-21291,
    CVE-2022-21283, CVE-2022-21282, CVE-2022-21277, CVE-2022-21248.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 20 Jan 2022 17:13:47 +0100

=== debian/tests/control ===
Test-Command: java --version
Depends: openjdk-17-jre-headless
Restrictions: superficial

Test-Command: javac --version
Depends: openjdk-17-jdk-headless
Restrictions: superficial

#Tests: hotspot, jaxp, langtools
#Depends: @, default-jre-headless, jtreg:native (>= 6+1-0~), testng:native, build-essential
#Restrictions: allow-stderr, skippable, flaky

#Tests: jdk
#Depends: @, default-jre-headless, jtreg:native (>= 6+1-0~), testng:native, build-essential, xfwm4:native, xvfb, dbus-x11
#Restrictions: allow-stderr, skippable, flaky

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?jdk-(\d[\d.]*\+\d[\d]*)\.tar\.gz%<project>-$1.tar.gz%, dversionmangle=s/~/+/" \
   https://github.com/openjdk/jdk17/tags \
   (?:.*?/)?jdk-(\d[\d.]*\+\d[\d]*)\.tar\.gz debian uupdate

## openjdk-17 17.0.3+7

=== debian/changelog ===
openjdk-17 (17.0.3+7-0ubuntu0.21.10.1) impish-security; urgency=medium

  * Backport 17.0.3 to Ubuntu 21.10.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Sun, 24 Apr 2022 10:03:57 -0400

openjdk-17 (17.0.3+7-0ubuntu0.22.04.1) jammy-security; urgency=medium

  * OpenJDK 17.0.3+7 build (release).
    - CVE-2022-21476, CVE-2022-21496, CVE-2022-21434, CVE-2022-21426,
      CVE-2022-21443, CVE-2022-21449

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Sun, 24 Apr 2022 09:50:52 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: openjdk-17
 Section: java
 Priority: optional
-Maintainer: OpenJDK Team <openjdk-17@packages.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: OpenJDK Team <openjdk-17@packages.debian.org>
 Uploaders: Matthias Klose <doko@ubuntu.com>
 Build-Depends: debhelper (>= 11),
   m4, lsb-release, zip, unzip,

## openjdk-17 17.0.4%2B8

=== debian/changelog ===
openjdk-17 (17.0.4+8-1~20.04) focal-security; urgency=medium

  * OpenJDK 17.0.4 release, build 8.
  * Addresses security issues: CVE-2022-34169, CVE-2022-21541,
    CVE-2022-21540, CVE-2022-21549.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 22 Jul 2022 10:57:45 +0200

openjdk-17 (17.0.4+8-1) unstable; urgency=high

  * OpenJDK 17.0.4+8 (release).
  * Disable the reproducible-copyright-headers patch.
  * Only try to re-run failed tests once instead of three times.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 20 Jul 2022 18:04:41 +0200

openjdk-17 (17.0.3+7-1) unstable; urgency=high

  * OpenJDK 17.0.3+7 (release).
  * Security fixes
    - JDK-8269938: Enhance XML processing passes redux.
    - JDK-8270504, CVE-2022-21426: Better XPath expression handling.
    - JDK-8272255: Completely handle MIDI files.
    - JDK-8272261: Improve JFR recording file processing.
    - JDK-8272588: Enhanced recording parsing.
    - JDK-8272594: Better record of recordings.
    - JDK-8274221: More definite BER encodings.
    - JDK-8275082, JDK-8278008, CVE-2022-21476: Update XML Security for Java
      to 2.3.0.
    - JDK-8275151, CVE-2022-21443: Improved Object Identification.
    - JDK-8277227: Better identification of OIDs.
    - JDK-8277233, CVE-2022-21449: Improve ECDSA signature support.
    - JDK-8277672, CVE-2022-21434: Better invocation handler handling.
    - JDK-8278356: Improve file creation.
    - JDK-8278449: Improve keychain support.
    - JDK-8278798: Improve supported intrinsic.
    - JDK-8278805: Enhance BMP image loading.
    - JDK-8278972, CVE-2022-21496: Improve URL supports.
    - JDK-8281388: Change wrapping of EncryptedPrivateKeyInfo.
  * Refresh patches.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 02 May 2022 20:04:05 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: openjdk-17
 Section: java
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: OpenJDK Team <openjdk-17@packages.debian.org>
+Maintainer: OpenJDK Team <openjdk-17@packages.debian.org>
 Uploaders: Matthias Klose <doko@ubuntu.com>
 Build-Depends: debhelper (>= 11),
   m4, lsb-release, zip, unzip,
   sharutils, gawk, cpio, pkg-config, procps, wdiff, fastjar (>= 2:0.96-0ubuntu2),
-  time, strip-nondeterminism, debugedit (>= 4.16),
+  time, strip-nondeterminism, 
   file,
   autoconf, automake, autotools-dev, ant, ant-optional,
-  g++-11 <!cross>,
+  g++-9 <!cross>,
   openjdk-17-jdk-headless:native | openjdk-16-jdk-headless:native,
   libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libfreetype6-dev (>= 2.2.1), libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig1-dev, libgtk2.0-0 | libgtk-3-0, libharfbuzz-dev,
   libffi-dev,

=== debian/rules ===
--- 
+++ 
@@ -172,7 +172,7 @@
 ifneq (,$(filter $(distrel), precise trusty))
   with_docs =
 endif
-with_check = disabled for this upload
+#with_check = disabled for this upload
 
 with_wqy_zenhai = $(if $(filter $(distrel),lenny),,yes)

## openjdk-17 17.0.4+8

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
 Build-Depends: debhelper (>= 11),
   m4, lsb-release, zip, unzip,
   sharutils, gawk, cpio, pkg-config, procps, wdiff, fastjar (>= 2:0.96-0ubuntu2),
-  time, strip-nondeterminism, 
-  file,
+  time, strip-nondeterminism, debugedit (>= 4.16),
+  jtreg6 (>= 6+1-0~) <!nocheck>, testng <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>,
   autoconf, automake, autotools-dev, ant, ant-optional,
-  g++-9 <!cross>,
+  g++-11 <!cross>,
   openjdk-17-jdk-headless:native | openjdk-16-jdk-headless:native,
   libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libfreetype6-dev (>= 2.2.1), libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig1-dev, libgtk2.0-0 | libgtk-3-0, libharfbuzz-dev,
   libffi-dev,

## openjdk-17 17.0.6%2B10

=== debian/changelog ===
openjdk-17 (17.0.6+10-1revyos1) unstable; urgency=medium

  [ YU BO ]
  * Add riscv64 jit

 -- Han Gao <gaohan@iscas.ac.cn>  Wed, 26 Apr 2023 18:40:15 +0800

openjdk-17 (17.0.6+10-1) unstable; urgency=high

  * OpenJDK 17.0.6 release, build 10.
    - CVE-2023-21835, CVE-2023-21843
    - Release notes:
      https://www.oracle.com/java/technologies/javase/17-0-6-relnotes.html

  [ Vladimir Petko ]
  * debian/patches/*: Refresh patches for the new release and drop unused
    patches.
  * debian/rules: add lunar to jtreg version selection.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Jan 2023 11:36:16 +0100

openjdk-17 (17.0.5+8-2) unstable; urgency=medium

  * Fix the binary-indep only build.

 -- Matthias Klose <doko@debian.org>  Wed, 19 Oct 2022 16:23:50 +0200

openjdk-17 (17.0.5+8-1) unstable; urgency=high

  * OpenJDK 17.0.5+8 (release).
  * Security fixes
    - JDK-8289366: Improve HTTP/2 client usage.
    - JDK-8288508: Enhance ECDSA usage.
    - JDK-8286918: Better HttpServer service.
    - JDK-8287446: Enhance icon presentations.
    - JDK-8286910: Improve JNDI lookups.
    - JDK-8286511: Improve macro allocation.
    - JDK-8286526: Improve NTLM support.
    - JDK-8286533: Key X509 usages.
    - JDK-8286077: Wider MultiByte conversions.
    - JDK-8286519: Better memory handling.
    - JDK-8285662: Better permission resolution.
    - JDK-8282252: Improve BigInteger/Decimal validation.
  * Build using GCC 12 in recent development distros.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 19 Oct 2022 06:59:58 +0200

=== debian/rules ===
--- 
+++ 
@@ -55,7 +55,7 @@
 
 multiarch_dir = /$(DEB_HOST_MULTIARCH)
 
-hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el s390x
+hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el riscv64 s390x
 jtreg_archs	= $(hotspot_archs) alpha ia64 powerpc ppc64 sh4 x32
 jtreg_archs	+= armel mipsel mips64el
 jtreg_archs	+= riscv64
@@ -157,10 +157,16 @@
   NJOBS = $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
 endif
 
-jtreg_pkg = jtreg6
+ifneq (,$(filter $(distrel), sid bookworm bullseye focal jammy kinetic lunar ))
+  jtreg_pkg = jtreg6
+else ifneq (,$(filter $(distrel), sid bookworm bullseye))
+  jtreg_pkg = jtreg
+else
+  jtreg_pkg =
+endif
 
 with_check = $(if $(findstring nocheck, $(DEB_BUILD_OPTIONS)),,yes)
-ifneq (,$(filter $(DEB_HOST_ARCH), alpha armel mipsel mips64el riscv64))
+ifneq (,$(filter $(DEB_HOST_ARCH), alpha armel mipsel mips64el))
   with_check = disabled running check on $(DEB_HOST_ARCH)
 endif
 # no jtreg backport yet
@@ -230,9 +236,3 @@
     export CC = $(DEB_HOST_GNU_TYPE)-gcc-5
     export CXX = $(DEB_HOST_GNU_TYPE)-g++-5
     # FIXME: altzero seems to build with GCC 5 on i386, amd64, ppc64el ...
-    ifneq (,$(filter $(DEB_HOST_ARCH), arm64))
-      ZERO_CC = $(DEB_HOST_GNU_TYPE)-gcc-4.9
-      ZERO_CXX = $(DEB_HOST_GNU_TYPE)-g++-4.9
-    endif
-  else
-    export CC = $(DEB_HOST_GNU_TYPE)-gcc-4.9

## openjdk-17 17.0.6+10

=== debian/changelog ===
openjdk-17 (17.0.6+10-1+rpi1) bookworm-staging; urgency=medium

  [changes taken from 17.0.4+8-1~deb11u1+rpt1 by Serge Schneider]
  * Build with client jvm variant
    - https://github.com/raspberrypi/linux/issues/3306#issuecomment-1030781000
  * Default to client jvm on armhf

 -- Raspbian forward porter <root@raspbian.org>  Mon, 13 Feb 2023 23:05:26 +0000

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
   time, strip-nondeterminism, debugedit (>= 4.16),
   jtreg6 (>= 6+1-0~) <!nocheck>, testng <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>,
   autoconf, automake, autotools-dev, ant, ant-optional,
-  g++-11 <!cross>,
+  g++-12 <!cross>,
   openjdk-17-jdk-headless:native | openjdk-16-jdk-headless:native,
   libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libfreetype6-dev (>= 2.2.1), libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig1-dev, libgtk2.0-0 | libgtk-3-0, libharfbuzz-dev,
   libffi-dev,

=== debian/rules ===
--- 
+++ 
@@ -55,7 +55,7 @@
 
 multiarch_dir = /$(DEB_HOST_MULTIARCH)
 
-hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el riscv64 s390x
+hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el s390x
 jtreg_archs	= $(hotspot_archs) alpha ia64 powerpc ppc64 sh4 x32
 jtreg_archs	+= armel mipsel mips64el
 jtreg_archs	+= riscv64
@@ -166,7 +166,7 @@
 endif
 
 with_check = $(if $(findstring nocheck, $(DEB_BUILD_OPTIONS)),,yes)
-ifneq (,$(filter $(DEB_HOST_ARCH), alpha armel mipsel mips64el))
+ifneq (,$(filter $(DEB_HOST_ARCH), alpha armel mipsel mips64el riscv64))
   with_check = disabled running check on $(DEB_HOST_ARCH)
 endif
 # no jtreg backport yet

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?jdk-(\d[\d.]*\+\d[\d]*)\.tar\.gz%<project>-$1.tar.gz%, dversionmangle=s/~/+/" \
   https://github.com/openjdk/jdk17u/tags \
   (?:.*?/)?jdk-(\d[\d.]*\+\d[\d]*)\.tar\.gz debian uupdate
